---
title: Set Up
sidebar_order: 4000
supported:
  - javascript
  - javascript.vue
  - react-native
  - dotnet
  - python
  - java
  - java.spring-boot
  - java.spring
  - go
  - android
  - ruby
  - apple
  - unity
  - dart
  - flutter
  - rust
  - native
  - php
  - node
notSupported:
  - javascript.cordova
  - native.breakpad
  - native.crashpad
  - native.minidumps
  - unreal
  - native.wasm
description: "Learn how to enable performance monitoring in your app if it is not already set up."
redirect_from:
  - /platforms/javascript/performance/apm-to-tracing/
---

<!-- Include in `notSupported` any SDK which enables tracing automatically -->

<PlatformSection supported={["native"]}>

<Note>

Performance monitoring is still an experimental, work-in-progress feature, and its API may be unstable. It may also have bugs. Feedback is appreciated, and should be submitted as an issue in the repository linked on the right side of this page.

</Note>

</PlatformSection>

<Note>

If you’re on a legacy plan, you'll need to add transaction events to your [subscription](https://sentry.io/pricing/) to use performance monitoring.

</Note>

With [performance monitoring](/product/performance/), Sentry tracks your software performance, measuring metrics like throughput and latency, and displaying the impact of errors across multiple systems. Sentry captures distributed traces consisting of transactions and spans, which measure individual services and individual operations within those services. Learn more about our model in [Distributed Tracing](/product/sentry-basics/tracing/distributed-tracing/).

<PlatformSection supported={["dotnet", "go", "java", "javascript.nextjs", "node", "php", "python", "ruby", "dart", "flutter", "rust", "native"]}>
<Note>

If you’re adopting Performance in a high-throughput environment, we recommend testing prior to deployment to ensure that your service’s performance characteristics maintain expectations.

</Note>
</PlatformSection>

<PlatformSection supported={["apple"]}>

Automatic instrumentation for monitoring the performance of your application is currently in preview. You can also use custom instrumentation to capture transactions.

</PlatformSection>

<PlatformSection supported={["javascript", "javascript.vue", "java.spring", "react-native"]} notSupported={["java", "go", "android", "ruby", "python", "dotnet", "dart", "native"]}>

## Enable Tracing

<PlatformContent includePath="performance/enable-tracing" />

</PlatformSection>

## Configure the Sample Rate

Sampling for transactions must also be configured before tracing is enabled in your app. Set the sample rate for your transactions by either:

1. Setting a uniform sample rate for all transactions using the <PlatformIdentifier name="traces-sample-rate" /> option in your SDK config to a number between `0` and `1`. (For example, to send 20% of transactions, set <PlatformIdentifier name="traces-sample-rate" /> to `0.2`.)
2. Controlling the sample rate based on the transaction itself and the context in which it's captured, by providing a function to the <PlatformIdentifier name="traces-sampler" /> config option.

The two options are meant to be mutually exclusive. If you set both, <PlatformIdentifier name="traces-sampler" /> will take precedence.

<PlatformContent includePath="performance/configure-sample-rate" />

Learn more about how the options work in <PlatformLink to="/configuration/sampling/">Sampling Transactions</PlatformLink>.

## Verify

<PlatformSection supported={["react-native", "java.spring", "java.spring-boot", "android", "javascript", "apple", "dart", "rust"]}>

Verify that performance monitoring is working correctly by using our <PlatformLink to="/performance/instrumentation/automatic-instrumentation/">automatic instrumentation</PlatformLink> or by starting and finishing a transaction using <PlatformLink to="/performance/instrumentation/custom-instrumentation/">custom instrumentation</PlatformLink>.

</PlatformSection>

<PlatformSection supported={["dotnet", "go", "java", "android", "ruby", "apple", "dart", "flutter", "native"]} notSupported={["javascript", "react-native", "java.spring", "java.spring-boot"]}>

Test out tracing by starting and finishing a transaction, which you _must_ do so transactions can be sent to Sentry. Learn how in our <PlatformLink to="/performance/instrumentation/custom-instrumentation/">Custom Instrumentation</PlatformLink> content.

</PlatformSection>

While you're testing, set <PlatformIdentifier name="traces-sample-rate" /> to `1.0`, as that ensures that every transaction will be sent to Sentry.

Once testing is complete, **we recommend lowering this value in production** by either lowering your <PlatformIdentifier name="traces-sample-rate" /> value, or switching to using <PlatformIdentifier name="traces-sampler" /> to dynamically sample and filter your transactions.

<PlatformSection supported={["javascript"]} notSupported={["react-native"]}>

Leaving the sample rate at `1.0` means that automatic instrumentation will send a transaction each time a user loads any page or navigates anywhere in your app, which is a lot of transactions. Sampling enables you to collect representative data without overwhelming either your system or your Sentry transaction quota.

</PlatformSection>

<!-- notSupported here should be the opposite of whats in common/connect-services.mdx -->

<PlatformSection notSupported={["javascript", "javascript.cordova", "php.laravel", "dart", "flutter", "android", "apple", "react-native", "javascript.capacitor", "native", "unreal", "dotnet"]}>

## Connecting Services

If you are also using Performance Monitoring for [JavaScript](/platforms/javascript/performance/), depending on where your request originates, you can connect traces:

1. For requests that start in your backend, by [adding a meta tag](/platforms/javascript/performance/connect-services/#pageload) in your HTML template that contains tracing information.
2. For requests that start in JavaScript, by the SDK [setting a header](/platforms/javascript/performance/connect-services/#navigation-and-other-xhr-requests) on requests to your backend.

Otherwise, backend services with Performance Monitoring connect automatically.

</PlatformSection>

<PlatformSection supported={["javascript.react"]}>

`@sentry/react` exports a `withProfiler` higher order component that can be used to capture React related spans for specific React components.

```javascript {filename: App.js}
import * as Sentry from "@sentry/react";

export default Sentry.withProfiler(App);
```

Learn more about using and customizing the React Profiler in [React Component Tracking](/platforms/javascript/guides/react/features/component-tracking/).

## React Router

If you are using `react-router`, we provide <PlatformLink to="/configuration/integrations/react-router/">React Router instrumentation</PlatformLink> to use with our `@sentry/tracing` package.

</PlatformSection>

<PlatformSection supported={["php"]}>

## Improve Response Time

Using the performance capabilities of PHP has some impact on your response time (depending on the `traces_sample_rate` you configured).
Because of the nature of PHP, in most cases, requests are sent in the same process as the one in which you serve your users' response.
In short, this process affects the time it takes to send a request to Sentry, because it is added to your servers' response time.

To account for this and reduce this addition to close to zero, you can use [Relay](/product/relay/getting-started/) running locally on the same machine or local network that acts as a proxy/agent. As a result, instead of your PHP process sending things to Sentry, the PHP process sends it to your local Relay, which then forwards it to Sentry.

To begin using Relay, check out our docs for [getting started](/product/relay/getting-started/).
Currently, we recommend using Relay in `managed` mode (which is the default).

Follow the instructions in the Relay docs to send a test event through Relay to Sentry.
Don't forget to update your `DSN` to point to your running Relay instance.
After you set up Relay, you should see a dramatic improvement to the impact on your server.

</PlatformSection>

**Next Steps:**

<PageGrid />
